/* --*-C-*-- */
/* $Id: gimev_options.c.pl,v 1.6 2002/06/19 06:02:49 itz Exp $ */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <getopt.h>
#include <sys/types.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "gimev_options.h"
#include "gim_public.h"

static struct option gimev_options[] = {
{* foreach $opt (@gimev_opts) {
  my $a = ($opt->{arg} ? 'required_argument' : 'no_argument');
  $OUT .= qq({ "$opt->{name}", $a, 0, '$opt->{flag}' },\n);
} *}
  { 0, 0, 0, 0 }
};

static const char gimev_docstrings[] = 
"{* $gimev_whatis *}\n"
"Usage: gimev [OPTION]... \n\n"
{* foreach $opt (@gimev_opts) {
    my $optline = qq(" -$opt->{flag}, --$opt->{name}");
    $optline .= qq( "=\U$opt->{name}") if $opt->{arg};
    $OUT .= $optline;
    $OUT .= ' "'. (" " x (($opt->{arg} ? 32 : 29) - length $optline)) . ' "';
    my $docstring = $opt->{docstring};
    $docstring =~ s|!NAME!|\U$opt->{name}| ;
    $OUT .= qq( "$docstring");
    $OUT .= qq(\n "\\n" \n);
} *}
  
"\nReport bugs to {* $email *}.\n"
;

void
print_gimev_version_and_copy()
{
  fprintf(stdout, "gimev %s\n", VERSION);
  fprintf(stdout, "{* printable($copy) *}");
  exit(0);
}

{* foreach $opt (@gimev_opts) {
  if ($opt->{arg}) {
    $OUT .= qq(char* opt_$opt->{name} = 0;\n);
  } else {
    $OUT .= qq(int opt_$opt->{name} = 0;\n);
  }
} *}

void
parse_gimev_options(int argc, char** argv)
{
  int c;
  int i;
  static char optlist[] = "{* foreach $opt (@gimev_opts) { $OUT .= $opt->{flag}; if ($opt->{arg}) { $OUT .= ':'; } } *}";

  while ((c = getopt_long(argc, argv, optlist, gimev_options, &i)) != -1) {
    switch(c) {
      {* foreach $opt (@gimev_opts) {
        $OUT .= qq(
	case '$opt->{flag}': );
        if ($opt->{arg}) {
          $OUT .= qq(opt_$opt->{name} = optarg; );
        } else {
          $OUT .= qq(opt_$opt->{name} = 1; );
        }
        $OUT .= qq(break;\n);
      } *}
	case '?':
	default:
	print_gimev_docstrings(1);
    } /*switch*/
  } /*while*/
}

int
print_gimev_docstrings (int exit_code)
{
  fprintf(stdout, gimev_docstrings);
  exit(exit_code);
  return 0;                     /* not reached */
}

int
process_gimev_command (int fd, char* buf, size_t bufsize)
{
  int status;
  struct gim_client_masks m;
  char* p;

  p = strtok(buf, " \t\n\r");
  if (p == 0) { strncpy(buf, "?", bufsize); return 0; }
{* foreach $cmd (@gimev_cmds) {
       if ($cmd->{arg}) {
           $OUT .= qq:  if (strcmp(p, "$cmd->{name}") == 0) {\n: ;
           $OUT .= qq:    status = gim_client_get_masks(fd, &m);\n: ;
           $OUT .= qq:    if (status < 0) return status;\n: ;
           $OUT .= qq:    p = strtok(0, " \\t\\n\\r");\n: ;
           $OUT .= qq:    m.$cmd->{name} = strtoul(p, 0, 0);\n: ;
           $OUT .= qq:    strncpy(buf, "ok", bufsize);\n: ;
           $OUT .= qq:    return gim_client_set_masks(fd, &m);\n: ;
           $OUT .= qq:  }\n: ;
       } elsif ($cmd->{result}) {
           $OUT .= qq(  if (strcmp(p, "$cmd->{name}") == 0) return gim_client_$cmd->{name}(fd, buf, bufsize);\n);
       } else {
           $OUT .= qq(  if (strcmp(p, "$cmd->{name}") == 0) { strncpy(buf, "ok", bufsize); return gim_client_$cmd->{name}(fd); }\n);
       }
     }
  *}
  strncpy(buf, "?", bufsize); return 0;
}

void
print_gimev_help (void)
{
  {* foreach $cmd (@gimev_cmds) {
       if ($cmd->{arg}) {
           $OUT .= qq(  fprintf(stdout, "%s ARG: %s\\n", "$cmd->{name}", "$cmd->{docstring}");\n) ;
       } else {
           $OUT .= qq(  fprintf(stdout, "%s: %s\\n", "$cmd->{name}", "$cmd->{docstring}");\n) ;
       }
     }
  *}
}
